/**
 * \file GraphPath.hpp
 *
 * Header file to declare the navigation graph path object
 *
 * \author Redouane Boumghar, Hung Cao
 *
 * \ingroup lgl
 *
 **/

#ifndef LGL_GRAPH_PATH_HPP
#define LGL_GRAPH_PATH_HPP

#include <list>
#include <iostream>

namespace jafar {
	namespace lgl {

		template <typename Vertex>
		class GraphPath;

		template <typename Vertex>
		std::ostream& operator<<(std::ostream&, const GraphPath<Vertex>&);

		/** Path inside the graph */
		template <typename Vertex>
		class GraphPath : public std::list< Vertex > {
			public:
				GraphPath() {}
				~GraphPath() {}
		
				template <typename V>
				friend std::ostream operator<< (std::ostream& out, const GraphPath<V>& path);
	  
		};

		template <typename Vertex>
		std::ostream& operator<<(std::ostream& out, const GraphPath<Vertex>& path)
		{
			typedef typename GraphPath<Vertex>::const_iterator path_iterator;
			for(path_iterator lit=path.begin(); lit!=path.end(); ++lit) {
		
				out << (*lit) << std::endl;

			}
			return out;
		}
}}
#endif //LGL_GRAPH_PATH_HPP
