/**
 * \file LandmarkBand.cpp
 *
 * Source file that defines landmark band specific functions
 * 
 *
 * \author Redouane Boumghar, Hung Cao
 *
 * \ingroup lgl
 *
 **/

#include <lgl/LandmarkBand.hpp>

namespace jafar { 
	namespace lgl {

		GDLandmarkBand::GDLandmarkBand(GDALDataset* _dataset, GDALRasterBand *_band):
		GDRasterBand<double>(_dataset,_band) 
		{

		}

		GDLandmarkBand::~GDLandmarkBand() {

		}

		bool GDLandmarkBand::isHomogeneous(const RasterRect& rect) const {
			if ( (getxsize_m(rect) > decompositionLimit
				|| getysize_m(rect) > decompositionLimit)
				&& decompositionLimit != -1.0 )
			{
				// To get large cells decomposed we return non-homogeneity
				return false;
			}

			bool result=true;
			// For now, the landmark band is always homogeneous
			// TODO landmark homegeneity definition
			return result;
		}

	}
}
