require "jafar/qdisplay"

puts "LGL ruby test"

$tfile = String.new("/home/hcao/workspace/tools/src/jafar/modules/lgl/test_suite/data/terrain3_greyscale.bmp");
$g = Jafar::Lgl::GeoData.new($tfile);

# print the geodata info
$g.printInfo(1);

$qt = Jafar::Lgl::QuadtreeD.new($g);
$posManager = Jafar::Lgl::PositionManager.new($g,$qt);
$nav = Jafar::Lgl::Nav.new($g,$qt,$posManager);

$decomp = $qt.getDecomp();

$view = Jafar::Lgl::LGLViewer.new($decomp,$nav.getNavGraph().getGraph());
 
#$costManager = $nav.getCM();

def inout(i,j)
  locs = Jafar::Lgl::LocationVector.new();
  $decomp.getInOutPoint(Jafar::Lgl::RasterCellIndex.new(i,j),locs)
  
  for i in (0..locs.size()-1)
	 print "(",locs.at(i).pos_x,",", locs.at(i).pos_y, ")"	 
  end
end

def enterLocs(x,y)
  locs = Jafar::Lgl::LocationVector.new();
  $posManager.getGEnterPos(Jafar::Lgl::NavLocation.new(x,y),locs)
  
  for i in (0..locs.size()-1)
	 print "(",locs.at(i).pos_x,",", locs.at(i).pos_y, ")"	 
  end
end

def getCluster(i,j)
  rect = Jafar::Lgl::RasterRect.new
  $qt.getClusterForCell(Jafar::Lgl::RasterCellIndex.new(i,j),rect);
  puts "Cluster is ",rect.xtopleft,":",rect.ytopleft,":",rect.xbottomright,":",rect.ybottomright,"\n";
end

def viewShowCell(i,j)
  v = $view.getQViewver;
  s = Jafar::Qdisplay::Shape.new(Jafar::Qdisplay::Shape::ShapeRectangle,2*j+1,2*i+1,2,2);
  s.setColor(255,0,0);
  v.addShape(s);
end

def viewShowCluster(i,j,h,w)
  centerx=i*2+h;
  centery=j*2+w;
  v = $view.getQViewver;
  s = Jafar::Qdisplay::Shape.new(Jafar::Qdisplay::Shape::ShapeRectangle,centery,centerx,w*2,h*2);
  s.setColor(255,0,0);
  v.addShape(s);
end

def viewShowPos(x,y)
  v = $view.getQViewver;
  s = Jafar::Qdisplay::Shape.new(Jafar::Qdisplay::Shape::ShapeCross,y,x,0.6,0.6);
  s.setColor(205,127,50);
  v.addShape(s);
end

def viewShowPath(p)
  v = $view.getQViewver;

  for i in (0..p.size()-1)
	 viewShowPos(p.at(i).pos_x,p.at(i).pos_y);
	 if (i>0)
		l = Jafar::Qdisplay::Line.new(p.at(i-1).pos_y,p.at(i-1).pos_x,p.at(i).pos_y,p.at(i).pos_x)
		l.setColor(255,0,0);
		v.addLine(l);
	 end
  end
end

def sameCluster(i,j,k,m)
  cell = Jafar::Lgl::RasterCellIndex.new
  if $posManager.inSameCluster(Jafar::Lgl::NavLocation.new(i,j), Jafar::Lgl::NavLocation.new(k,m), cell)
	 print cell.i,",", cell.j,"\n"
  end
end

def adjClusters(x,y)
  clusters = Jafar::Lgl::CellVector.new;
  $posManager.getAdjClusters(Jafar::Lgl::NavLocation.new(x,y), clusters);
  for i in (0..clusters.size()-1)
	 print clusters.at(i).i,",", clusters.at(i).j, "\n"
  end
end

def adjCells(x,y)
  cells = Jafar::Lgl::CellVector.new;
  $posManager.getAdjRasterCells(Jafar::Lgl::NavLocation.new(x,y), cells);
  for i in (0..cells.size()-1)
	 print cells.at(i).i,",", cells.at(i).j, "\n"
  end
end

def checkCost(xstart,ystart,xend,yend)
  ng = $nav.getNavGraph
  bg = ng.getGraph
  b = Jafar::Lgl::NavGEdge.new
  
  bg.getEdgeBundle(Jafar::Lgl::NavLocation.new(xstart,ystart),Jafar::Lgl::NavLocation.new(xend,yend),b,true)
  
  print "Cost = ", b.weight, "\n"
end

def find(xstart,ystart,xend,yend)
  loc1 = Jafar::Lgl::NavLocation.new(xstart,ystart);
  loc2 = Jafar::Lgl::NavLocation.new(xend,yend);
  path = Jafar::Lgl::Path.new();
  $nav.find(loc1,loc2,path);

  for i in (0..path.size()-1)
	 print "(",path.at(i).pos_x,",", path.at(i).pos_y, ") -->"	 
  end

  viewShowPath(path);
end

def weight(xstart,ystart,xend,yend)
  loc1 = Jafar::Lgl::NavLocation.new(xstart,ystart);
  loc2 = Jafar::Lgl::NavLocation.new(xend,yend);

  w = Jafar::Lgl::new_floatp;
  $costManager.weight(loc1,loc2,w);

  print "The cost = ", Jafar::Lgl::floatp_value(w), "\n";

end
